unit main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, RTSP, StdCtrls, Winsock, ExtCtrls;

type
  TForm1 = class(TForm)
    Memo1: TMemo;
    Label1: TLabel;
    Edit1: TEdit;
    Edit2: TEdit;
    Label2: TLabel;
    Label3: TLabel;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
    RTSP:TRTSPClient;
    MPEG:TFileStream;
    TotalSize:integer;
    procedure OnEvent(Sender:TObject; Event:TEvent; Value:integer);
    procedure OnDecode(Sender:TObject; Size:integer; Data:pointer);
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.dfm}

function FileSize(i:integer):string;
var
 k,m:integer;
begin
 Result:='';
 if i>1024 then begin
  k:=i div 1024;
  if k>1024 then begin
   m:=k div 1024;
   if m>0 then begin
    Result:=IntToStr(m)+' Mo ';
    dec(k,1024*m);
    dec(i,1024*1024*m);
   end;
  end;
  if k>0 then begin
   Result:=Result+IntToStr(k)+' Ko ';
   dec(i,1024*k);
  end;
 end;
 if (i>0) then Result:=Result+IntToStr(i)+' octets';
end;

procedure TForm1.FormCreate(Sender: TObject);
// Gulli rtsp://mafreebox.freebox.fr/freeboxtv/419
// NT1   rtsp://mafreebox.freebox.fr/freeboxtv/374
begin
 RTSP:=TRTSPClient.Create;
 RTSP.OnEvent:=OnEvent;
 RTSP.OnDecode:=OnDecode;
end;

procedure TForm1.OnEvent(Sender:TObject; Event:TEvent; Value:integer);
begin
 case Event of
  evError  : Memo1.Lines.Add('error '+IntToStr(Value));
  evWSError: Memo1.Lines.Add('WINSOCK Error #'+IntToStr(Value));
  evSend   : Memo1.Lines.add(RTSP.Request);
  evRecv   : Memo1.Lines.add(RTSP.Header+#13#10+RTSP.Data);
  evCTRL   : Memo1.Lines.add('RTCP Control for sequence '+IntToStr(Value));
  evDone   : Memo1.Lines.add('Video recevied : '+IntToStr(Value)+' bytes');
 end;
end;

procedure TForm1.OnDecode(Sender:TObject; Size:integer; Data:pointer);
begin
 if MPEG<>nil then begin
  MPEG.WriteBuffer(Data^,Size);
  inc(TotalSize,size);
  Label1.Caption:=FileSize(TotalSize);
 end;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
 if RTSP=nil then exit;
 if RTSP.Playing then begin
  CanClose:=False;
  RTSP.Stop;
 end else begin
  MPEG.Free;
  CanClose:=True;
 end;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
 if Button1.Tag=0 then begin
  Button1.Tag:=1;
  Button1.Caption:='Stop';
  MPEG:=TFileStream.Create(Edit2.Text,fmCreate or fmShareDenyWrite);
  TotalSize:=0;
  RTSP.Open(Edit1.Text);
 end else begin
  Button1.Tag:=0;
  Button1.Caption:='Sauver';
  RTSP.Stop;
  FreeAndNil(MPEG);
 end;
end;

end.

